#Code for producing Figure 2 of the paper

tmp<-function(n,j,d,M) { d*(1-(1-(choose(n-d,j-d+1)+(d-1)*choose(n-d,j-d+2))/choose(n,j))^M)-d+1 }

pdf("Figure 2.pdf", width=8, height=8)
par(mfrow=c(2,1))

n<-100
d<-10
mvect<-c(500,1000,2000,3000,4000,5000,10000)
jvect<-1:(n/2)
res<-matrix(0,length(mvect),length(jvect))  
  
for(m in 1:length(mvect)) {
  
  for(j in 1:length(jvect)) {
  
  res[m,j]<-tmp(n,jvect[j],d,mvect[m])
  
}}

res[res<0]<-0
plot(jvect,res[1,],ylim=c(0,1),type="l",xlab="# of deleted observations j",ylab="Lower Bound",main="n=100",lwd=2)
abline(h=1,lty=3,lwd=1.6)
for(i in 2:length(mvect)) lines(jvect,res[i,],lwd=2)
text(49.5,0.39,"M=500")  
text(28.84,0.59,"M=10 000")


n<-1000
d<-10
mvect<-c(500,1000,2000,3000,4000,5000,10000)
jvect<-1:(n/2)
res<-matrix(0,length(mvect),length(jvect))  

for(m in 1:length(mvect)) {
  
  for(j in 1:length(jvect)) {
    
    res[m,j]<-tmp(n,jvect[j],d,mvect[m])
    
  }}

res[res<0]<-0
plot(jvect,res[1,],ylim=c(0,1),type="l",xlab="# of deleted observations j",ylab="Lower Bound",main="n=1000",lwd=2)
abline(h=1,lty=3,lwd=1.6)
for(i in 2:length(mvect)) lines(jvect,res[i,],lwd=2)
text(485,0.21,"M=500")  
text(254.4,0.42,"M=10 000")

dev.off()