#Code for producing Figure 3 of the paper.
##########
library(dr)
library(robustbase)
hbk
attach(hbk)
temp=dr(Y~X1+X2+X3,method="sir")
plot(dr.directions(temp)[,1],dr.directions(temp)[,2],xlab="First SIR Coordinate",ylab="Second SIR Coordinate",main="SIR Coordinate Plot - Hawkins-Bradu-Kass Data")
par(cex=0.7)
identify(dr.directions(temp)[,1],dr.directions(temp)[,2])
par(cex=1)
temp=dr(Y~X1+X2+X3,method="save")
plot(dr.directions(temp)[,1],dr.directions(temp)[,2],xlab="First SAVE Coordinate",ylab="Second SAVE Coordinate",main="SAVE Coordinate Plot - Hawkins-Bradu-Kass Data")
par(cex=0.7)
identify(dr.directions(temp)[,1],dr.directions(temp)[,2])
par(cex=1)
# 3D plots
library(rgl)
temp=dr(Y~X1+X2+X3,method="sir")
tmp=dr.directions(temp)
sir1=tmp[,1];sir2=tmp[,2]
plot3d(sir1,sir2,Y)
temp=dr(Y~X1+X2+X3,method="save")
tmp=dr.directions(temp)
save1=tmp[,1];save2=tmp[,2]
plot3d(save1,save2,Y)
