##########
#Real Examples
##########
library(BMA)
library(forward)
library(robustbase)
source("../../Functions/Functions.R")
##########
#HBK data
##########
attach(hbk)
set.seed(1)
x<-as.matrix(hbk[,1:3])
y<-as.matrix(hbk[,4])
res1<-MC3.REG(y,x,num.its=5000)
nout<-res1$outlier.numbers
nout
> nout
[1]  1  2  3  4  5  6  7  8  9 10
res2<-adaptivereal(x,y,M=5000,j=37,ran=FALSE)
res<-round(res2[[2]][,c(3,1,2)],2)
res[which(res[,2]>1),]
> res[which(res[,2]>1),]
step1 temp
1  0.04   4.88 8.12
2  0.05   5.47 8.42
3  0.05   6.71 8.10
4  0.03   4.96 7.01
5  0.04  34.12 7.65
6  0.05   6.56 8.05
7  0.08 108.83 9.00
8  0.05   6.03 8.80
9  0.03  14.18 7.37
10 0.05  94.27 8.06
11 0.35  16.46 0.55
12 0.85  25.62 0.51
13 0.25  14.32 0.76
14 2.11  22.73 0.55
34 0.00   1.40 0.04
47 0.01   1.96 0.10
##########
#Salinity Data
##########
data(salinity) 
set.seed(1)
x<-as.matrix(salinity[,1:3])
y<-as.matrix(salinity[,4])
res1<-MC3.REG(y,x,num.its=5000)
nout<-res1$outlier.numbers
nout
> nout
[1]  5  8 16 23 24
#method breaks down with j=14
res2<-adaptivereal(x,y,M=5000,j=14,ran=FALSE)
which(res2[[1]]>0)
> which(res2[[1]]>0)
[1]  1  2  3  4  5  6  7  8  9 10 11 13 14 15 16 17 18 19 20 21 22 23 24 26 27 28
#use j=7
res2<-adaptivereal(x,y,M=5000,j=7,ran=FALSE)
which(res2[[1]]>0)
> which(res2[[1]]>0)
[1]  5 16
res<-round(res2[[2]][,c(3,1,2)],2)
res[which(res[,2]>1),]
> res[which(res[,2]>1),]
step1 temp
5  0.01 11.68 1.27
9  0.20  2.69 0.13
15 0.18  2.32 0.30
16 2.78 35.45 4.81
19 0.05  1.39 0.01
23 0.00  5.17 0.33
24 0.02  2.87 0.22
##########
#Diabetes Data
##########
library(lars)
data(diabetes) #wle package
set.seed(1)
x<-as.matrix(diabetes$x2)
temp<-NULL
for(i in 1:64) temp<-cbind(temp,x[,i])
y<-as.matrix(diabetes$y)
res1<-MC3.REG(y,temp,num.its=5000)
nout<-res1$outlier.numbers
nout
> res1<-MC3.REG(y,temp,num.its=5000)
There were 50 or more warnings (use warnings() to see the first 50)
> nout<-res1$outlier.numbers
> nout
[1]   1  10  38  57  93 103 113 114 124 148 153 157 191 200 206 211 212 223 233 237 275
[22] 281 283 284 291 305 323 329 331 354 360 361 365 369 379 381 386 388 395 399 406
> warnings()
Warning messages:
  1: In matrix(as.logical(rep(g$big.list[, 1] - 1, rep(length(g$M0.var),  ... :
                                                         probable complete loss of accuracy in modulus
res2<-adaptivereal(temp,y,M=5000,j=221,ran=FALSE)
which(res2[[1]]>0)
length(which(res2[[2]][,1]>1))
length(which(res2[[2]][,2]>1))
> res2<-adaptivereal(temp,y,M=5000,j=221,ran=FALSE)
> which(res2[[1]]>0)
integer(0)
> length(which(res2[[2]][,1]>1))
[1] 59
> length(which(res2[[2]][,2]>1))
[1] 0
