library(BMA)
library(mnormt)
library(doRNG)
library(doParallel)
library(doRNG)
registerDoParallel(25)
source("../../../Functions/Functions.R")
##########
set.seed(123)
nsims<-100
##########
nvect<-c(60)
outvect<-c(2,5,10)
pvect<-c(2,5,10,15)
xdelta<-3
ydelta<-3
##########
results1<-NULL
for(n in nvect) {
  
  for(p in pvect) {
    
    for(out in outvect) {
      
      x<-matrix(rnorm(n*p),n,p)
      x[1:out,1:p]<-xdelta+matrix(rnorm(out*p,0,0.25),out,p)
      
      results<-foreach(k=1:nsims,.packages=c('BMA'),.inorder=TRUE,.combine='rbind') %dorng% {
        
        temp<-rep(0,max(nvect))
        ymean<-1+x%*%c(rep(1,min(p,5)),rep(0,max(0,p-5)))
        y<-rnorm(n=n,ymean,1)
        y[1:out]<-ydelta*ymean[1:out]+rnorm(out,0,0.25)    
        res1<-MC3.REG(y,x,num.its=5000)
        prob<-apply(res1$post.prob * res1$outliers,2,sum)
        nout<-res1$outlier.numbers
        temp[nout]<-prob
        res2<-adaptiveold(x,y,M=5000,j=(n/2),ran=FALSE)
        res2<-c(sum(res2[1:out]>0),sum(res2[-(1:out)]>0))
        
        c(sum(temp[1:out]>0),sum(temp[-(1:out)]>0),sum(temp[1:out]>0.2),sum(temp[-(1:out)]>0.2),res2)        
      }
      
      results1<-rbind(results1,results)
    }
  }
}
save.image("ModCook.RData")
##########
nvect<-c(100)
outvect<-c(2,5,10,15)
pvect<-c(5,10,15,20,40)
xdelta<-3
ydelta<-3
##########
results2<-NULL
for(n in nvect) {
  
  for(p in pvect) {
    
    for(out in outvect) {
      
      x<-matrix(rnorm(n*p),n,p)
      x[1:out,1:p]<-xdelta+matrix(rnorm(out*p,0,0.25),out,p)
      
      results<-foreach(k=1:nsims,.packages=c('BMA'),.inorder=TRUE,.combine='rbind') %dorng% {
        
        temp<-rep(0,max(nvect))
        ymean<-1+x%*%c(rep(1,min(p,5)),rep(0,max(0,p-5)))
        y<-rnorm(n=n,ymean,1)
        y[1:out]<-ydelta*ymean[1:out]+rnorm(out,0,0.25)    
        res1<-MC3.REG(y,x,num.its=5000)
        prob<-apply(res1$post.prob * res1$outliers,2,sum)
        nout<-res1$outlier.numbers
        temp[nout]<-prob
        res2<-adaptiveold(x,y,M=5000,j=(n/2),ran=FALSE)
        res2<-c(sum(res2[1:out]>0),sum(res2[-(1:out)]>0))
        
        c(sum(temp[1:out]>0),sum(temp[-(1:out)]>0),sum(temp[1:out]>0.2),sum(temp[-(1:out)]>0.2),res2)        
      }
      
      results2<-rbind(results2,results)
    }
  }
}
save.image("ModCook.RData")
##########
nvect<-c(200,400)
outvect<-c(2,5,10,15,20)
pvect<-c(5,10,20,40)
xdelta<-3
ydelta<-3
##########
results3<-NULL
for(n in nvect) {
  
  for(p in pvect) {
    
    for(out in outvect) {
      
      x<-matrix(rnorm(n*p),n,p)
      x[1:out,1:p]<-xdelta+matrix(rnorm(out*p,0,0.25),out,p)
      
      results<-foreach(k=1:nsims,.packages=c('BMA'),.inorder=TRUE,.combine='rbind') %dorng% {
        
        temp<-rep(0,max(nvect))
        ymean<-1+x%*%c(rep(1,min(p,5)),rep(0,max(0,p-5)))
        y<-rnorm(n=n,ymean,1)
        y[1:out]<-ydelta*ymean[1:out]+rnorm(out,0,0.25)    
        res1<-MC3.REG(y,x,num.its=5000)
        prob<-apply(res1$post.prob * res1$outliers,2,sum)
        nout<-res1$outlier.numbers
        temp[nout]<-prob
        res2<-adaptiveold(x,y,M=5000,j=(n/2),ran=FALSE)
        res2<-c(sum(res2[1:out]>0),sum(res2[-(1:out)]>0))
        
        c(sum(temp[1:out]>0),sum(temp[-(1:out)]>0),sum(temp[1:out]>0.2),sum(temp[-(1:out)]>0.2),res2)        
      }
      
      results3<-rbind(results3,results)
    }
  }
}
save.image("ModCook.RData")
##########
nvect<-c(100)
outvect<-c(10)
pvect<-c(5,10,15,20)
xdelta<-3
ydelta<-3
##########
results4<-NULL
for(n in nvect) {
  
  for(p in pvect) {
    
    for(out in outvect) {
      
      x<-matrix(rnorm(n*p),n,p)
      x[1:out,1:p]<-xdelta+matrix(rnorm(out*p,0,0.25),out,p)
      x[1:(out/2),]<--x[1:(out/2),]
      
      results<-foreach(k=1:nsims,.packages=c('BMA'),.inorder=TRUE,.combine='rbind') %dorng% {
        
        temp<-rep(0,max(nvect))
        ymean<-1+x%*%c(rep(1,min(p,5)),rep(0,max(0,p-5)))
        y<-rnorm(n=n,ymean,1)
        y[1:out]<-ydelta*ymean[1:out]+rnorm(out,0,0.25)
        res1<-MC3.REG(y,x,num.its=5000)
        prob<-apply(res1$post.prob * res1$outliers,2,sum)
        nout<-res1$outlier.numbers
        temp[nout]<-prob
        res2<-adaptiveold(x,y,M=5000,j=(n/2),ran=FALSE)
        res2<-c(sum(res2[1:out]>0),sum(res2[-(1:out)]>0))
        
        c(sum(temp[1:out]>0),sum(temp[-(1:out)]>0),sum(temp[1:out]>0.2),sum(temp[-(1:out)]>0.2),res2)        
      }
      
      results4<-rbind(results4,results)
    }
  }
}
save.image("ModCook.RData")
##########
nvect<-c(200,400)
outvect<-c(10)
pvect<-c(5,10,20,40)
xdelta<-3
ydelta<-3
##########
results5<-NULL
for(n in nvect) {
  
  for(p in pvect) {
    
    for(out in outvect) {
      
      x<-matrix(rnorm(n*p),n,p)
      x[1:out,1:p]<-xdelta+matrix(rnorm(out*p,0,0.25),out,p)
      x[1:(out/2),]<--x[1:(out/2),]
      
      results<-foreach(k=1:nsims,.packages=c('BMA'),.inorder=TRUE,.combine='rbind') %dorng% {
        
        temp<-rep(0,max(nvect))
        ymean<-1+x%*%c(rep(1,min(p,5)),rep(0,max(0,p-5)))
        y<-rnorm(n=n,ymean,1)
        y[1:out]<-ydelta*ymean[1:out]+rnorm(out,0,0.25)
        res1<-MC3.REG(y,x,num.its=5000)
        prob<-apply(res1$post.prob * res1$outliers,2,sum)
        nout<-res1$outlier.numbers
        temp[nout]<-prob
        res2<-adaptiveold(x,y,M=5000,j=(n/2),ran=FALSE)
        res2<-c(sum(res2[1:out]>0),sum(res2[-(1:out)]>0))
                
                c(sum(temp[1:out]>0),sum(temp[-(1:out)]>0),sum(temp[1:out]>0.2),sum(temp[-(1:out)]>0.2),res2)        
      }
      
      results5<-rbind(results5,results)
    }
  }
}
save.image("ModCook.RData")
##########
# n<-500
# xdelta<-3
# ydelta<-3
# p<-50
# out<-10
# x<-matrix(rnorm(n*p),n,p)
# x[1:5,]<--x[1:5,]
# #cov.mat<-(0.8)^(abs(outer(1:p,1:p,"-")))
# #x<-rmnorm(n=n,mean=0,varcov=cov.mat)    
# x[1:out,1:p]<-xdelta+matrix(rnorm(out*p,0,0.25),out,p)
# ymean<-1+x%*%c(rep(1,min(p,5)),rep(0,max(0,p-5)))
# y<-rnorm(n=n,ymean,1)
# y[1:out]<-ydelta*ymean[1:out]+rnorm(out,0,0.25)
# #y[1:5]<--y[1:5]
# # y[6:10]<--y[6:10]
# # x[6:10,]<-x[6:10,]
# # y[11:15]<-y[11:15]
# # x[11:15,]<--x[11:15,]
# pairs(cbind(x,y))
# res1<-rep(0,out)
# res2<-rep(0,out)
# for(i in 1:out) res1[i]<-cooks.distance(lm(y[-(1:out)[-i]]~x[-(1:out)[-i],]))[1]
# res2<-cooks.distance(lm(y~x))[1:out]
# min(res1)
# max(res2)

